// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.20.1
// source: utils/api/proto/sha3hasher.proto

package sha3hasher

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// Sha3HasherClient is the client API for Sha3Hasher service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type Sha3HasherClient interface {
	Hash(ctx context.Context, opts ...grpc.CallOption) (Sha3Hasher_HashClient, error)
}

type sha3HasherClient struct {
	cc grpc.ClientConnInterface
}

func NewSha3HasherClient(cc grpc.ClientConnInterface) Sha3HasherClient {
	return &sha3HasherClient{cc}
}

func (c *sha3HasherClient) Hash(ctx context.Context, opts ...grpc.CallOption) (Sha3Hasher_HashClient, error) {
	stream, err := c.cc.NewStream(ctx, &Sha3Hasher_ServiceDesc.Streams[0], "/sha3hasher.Sha3Hasher/Hash", opts...)
	if err != nil {
		return nil, err
	}
	x := &sha3HasherHashClient{stream}
	return x, nil
}

type Sha3Hasher_HashClient interface {
	Send(*Sha3Request) error
	Recv() (*Sha3Response, error)
	grpc.ClientStream
}

type sha3HasherHashClient struct {
	grpc.ClientStream
}

func (x *sha3HasherHashClient) Send(m *Sha3Request) error {
	return x.ClientStream.SendMsg(m)
}

func (x *sha3HasherHashClient) Recv() (*Sha3Response, error) {
	m := new(Sha3Response)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Sha3HasherServer is the server API for Sha3Hasher service.
// All implementations must embed UnimplementedSha3HasherServer
// for forward compatibility
type Sha3HasherServer interface {
	Hash(Sha3Hasher_HashServer) error
	mustEmbedUnimplementedSha3HasherServer()
}

// UnimplementedSha3HasherServer must be embedded to have forward compatible implementations.
type UnimplementedSha3HasherServer struct {
}

func (UnimplementedSha3HasherServer) Hash(Sha3Hasher_HashServer) error {
	return status.Errorf(codes.Unimplemented, "method Hash not implemented")
}
func (UnimplementedSha3HasherServer) mustEmbedUnimplementedSha3HasherServer() {}

// UnsafeSha3HasherServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to Sha3HasherServer will
// result in compilation errors.
type UnsafeSha3HasherServer interface {
	mustEmbedUnimplementedSha3HasherServer()
}

func RegisterSha3HasherServer(s grpc.ServiceRegistrar, srv Sha3HasherServer) {
	s.RegisterService(&Sha3Hasher_ServiceDesc, srv)
}

func _Sha3Hasher_Hash_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(Sha3HasherServer).Hash(&sha3HasherHashServer{stream})
}

type Sha3Hasher_HashServer interface {
	Send(*Sha3Response) error
	Recv() (*Sha3Request, error)
	grpc.ServerStream
}

type sha3HasherHashServer struct {
	grpc.ServerStream
}

func (x *sha3HasherHashServer) Send(m *Sha3Response) error {
	return x.ServerStream.SendMsg(m)
}

func (x *sha3HasherHashServer) Recv() (*Sha3Request, error) {
	m := new(Sha3Request)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Sha3Hasher_ServiceDesc is the grpc.ServiceDesc for Sha3Hasher service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Sha3Hasher_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "sha3hasher.Sha3Hasher",
	HandlerType: (*Sha3HasherServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Hash",
			Handler:       _Sha3Hasher_Hash_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "utils/api/proto/sha3hasher.proto",
}
